#!/usr/local/bin/perl

$mailprog = '/bin/sendmail';

# valid referers
@referers = ('.*order4\.html', '.*shopwizard_order\.cgi');

# required fields
#@required = ("shipping_region", "shipping_method", "tax_area");

&check_referer;
&parse_form;
&check_required;
&get_date;
&send_email;
&print_html;

sub get_date {
	@days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	@months = ('January','February','March','April','May','June','July','August','September','October','November','December');

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	if ($hour < 10) { $hour = "0$hour"; }
	if ($min < 10) { $min = "0$min"; }
	if ($sec < 10) { $sec = "0$sec"; }

	$date = "$days[$wday], $months[$mon] $mday, $year at $hour\:$min\:$sec";
}

sub send_email {

	if($FORM{'recipient'} eq "") {
		print "Content-type: text/html\n\n";

		print "<body";
		&body_attributes;
		print ">\n";
		print "<center><img src=\"lockssl-on.gif\"></center><br>\n";
		print "<br><br><br><br><center>\n";
		print "<font size=\"+2\">$FORM{'ln_email_required'}</font><br><br>\n";
		print "</center>";
		print "</body>\n</html>";
		die;
	}

	open(MAIL,"|$mailprog -t");
	print MAIL "To: $FORM{'recipient'}\n";
	print MAIL "From: $FORM{'customer_email'} ($FORM{'customer_name'})\n";
	print MAIL "Subject: Order From $FORM{'shopname'}\n";
	print MAIL "\n----------------------------------------\n";
	print MAIL "Below is an order from $FORM{'shopname'}\n";
	print MAIL "Submitted by: $FORM{'customer_name'}\n";
	print MAIL "       email: $FORM{'customer_email'}\n";
	print MAIL "        date: $date\n";
	print MAIL "----------------------------------------\n\n";

	print MAIL "$FORM{'order_email'}\n";
	print MAIL "\n----- $FORM{'ln_payment_method'} -----\n";

	print MAIL "$FORM{'ln_cc_type'}: $FORM{'card_type'}\n";
	print MAIL "$FORM{'ln_cc_name'}: $FORM{'card_name'}\n";
	print MAIL "$FORM{'ln_cc_number'}: $FORM{'card_number'}\n";
	print MAIL "$FORM{'ln_cc_expiry'}: $FORM{'card_exp_month'}\/$FORM{'card_exp_year'}\n";

	print MAIL "\n----- $FORM{'ln_total'} -----\n";
	print MAIL "$FORM{'ln_total_weight'}: $FORM{'total_weight'}\n";
	print MAIL "$FORM{'ln_purchase_price'}: $FORM{'currency_symbol'}$FORM{'total_ex_tax'}\n";
	print MAIL "$FORM{'ln_total_tax'}: $FORM{'currency_symbol'}$FORM{'tax_value'}\n";
	print MAIL "$FORM{'ln_total_shipping'}: $FORM{'currency_symbol'}$FORM{'shipping_value'}\n";
	print MAIL "$FORM{'ln_total_inc'}: $FORM{'currency_symbol'}$FORM{'total_inc_tax'}\n";

	print MAIL "\nBrowser: $ENV{'HTTP_USER_AGENT'}\n";
	print MAIL "Remote Host: $ENV{'REMOTE_HOST'}\n";
	print MAIL "Remote Address: $ENV{'REMOTE_ADDR'}\n";

	close (MAIL);
}

sub print_html {
	print "Content-type: text/html\n\n";

	print "<head>\n";
	print "<meta http-equiv=\"refresh\" content=\"3;url=$FORM{'thankyou_url'}\">\n";
	print "</head>\n";
	print "<body";
	&body_attributes;
	print ">\n";
	print "<center><img src=\"lockssl-on.gif\"></center><br>\n";
	print "<br><br><br><br><center>\n";
	print "<font size=\"+2\">$FORM{'ln_secure_final'}.</font><br><br>\n";
	print "<a href=\"$FORM{'thankyou_url'}\"><font size=\"-1\">$FORM{'ln_next'}</font></a>\n";
	print "</center>";
	print "</body>\n</html>";
}

sub check_referer {
	if ($ENV{'HTTP_REFERER'}) {
		foreach $referer (@referers) {
			if ($ENV{'HTTP_REFERER'} =~ /$referer/i) {
				$referer_ok = '1';
				last;
			}
		}
	} else {
		$referer_ok = '1';
	}

	if ($referer_ok != 1) {
		&error('bad_referer');
	}
}

sub check_required {
	foreach $require (@required) {
		if ($require eq 'bgcolor' ||
			$require eq 'background' ||
			$require eq 'text_color' ||
			$require eq 'link_color' ||
			$require eq 'alink_color' ||
			$require eq 'vlink_color') {
			if (!($CONFIG{$require}) || $CONFIG{$require} eq ' ') {
				push(@ERROR, $require);
			}
		} elsif (!($FORM{$require}) || $FORM{$require} eq ' ') {
			push(@ERROR, $require);
		}
	}
	if (@ERROR) {
		&error('missing_fields', @ERROR);
	}
}

sub parse_form {

	if ($ENV{'REQUEST_METHOD'} =~ 'GET') {
		@pairs = split(/&/, $ENV{'QUERY_STRING'});		# Split the name-value pairs
	} elsif ($ENV{'REQUEST_METHOD'} =~ 'POST') {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});	# Get the input
		@pairs = split(/&/, $buffer);					# Split the name-value pairs
	} else {
		&error('request_method');
	}

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);			# Split pair into name and value

		$name =~ tr/+/ /;								# un-URL-encode the name
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;								# un-URL-encode the value
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		$value =~ s/<!--(.|\n)*-->//g;					# remove possible SSI directives from value

		if ($name eq 'bgcolor' ||
			$name eq 'background' ||
			$name eq 'text_color' ||
			$name eq 'link_color' ||
			$name eq 'alink_color' ||
			$name eq 'vlink_color' && ($value)) {
			$CONFIG{$name} = $value;
		} else {
			if ($FORM{$name} && ($value)) {
				$FORM{$name} = "$FORM{$name}, $value";
			} elsif ($value) {
				$FORM{$name} = $value;
			}
		}
	}
}

sub error {
	($error, @error_fields) = @_;

	print "Content-type: text/html\n\n";
	print "<html>\n<body";
	&body_attributes;
	print ">\n";

	if ($error eq 'bad_referer') {
		print "<center>\n<h1>Bad Referrer - Access Denied</h1>\n</center>\n";
		print "The form that is trying to use this CGI application\n";
		print "resides at: $ENV{'HTTP_REFERER'}, which is not allowed access.\n";
	} elsif ($error eq 'request_method') {
		print "<center>\n<h1>Error: Request Method</h1>\n</center>\n";
		print "The Request Method of the submitted form did not match\n";
		print "either GET or POST.<p>\n";
	} elsif ($error eq 'missing_fields') {
		print "<center>\n<h1>Error: Missing Fields</h1>\n</center>\n";
		print "The following fields require values:<p>\n";
		print "<ul>\n";
		foreach $missing_field (@error_fields) {
			print "<li>$missing_field\n";
		}
		print "</ul>\n";
	}

	print "<p><hr size=\"2\"></p>\n";
	print "<center><a href=\"$ENV{'HTTP_REFERER'}\">Go back</a>\n";
	print "</body>\n</html>\n";

	exit;
}

sub body_attributes {
	if ($CONFIG{'bgcolor'}) {
		print " bgcolor=\"$CONFIG{'bgcolor'}\"";
	}
	if ($CONFIG{'background'} =~ /http\:\/\/.*\..*/) {
		print " background=\"$CONFIG{'background'}\"";
	}
	if ($CONFIG{'link_color'}) {
		print " link=\"$CONFIG{'link_color'}\"";
	}
	if ($CONFIG{'vlink_color'}) {
		print " vlink=\"$CONFIG{'vlink_color'}\"";
	}
	if ($CONFIG{'alink_color'}) {
		print " alink=\"$CONFIG{'alink_color'}\"";
	}
	if ($CONFIG{'text_color'}) {
		print " text=\"$CONFIG{'text_color'}\"";
	}
}